from gpiozero import LED

ledr = LED(6)
ledg = LED(5)
ledb = LED(13)

leds = [ledr, ledg, ledb]

def redlight():
    ledr.on()

def greenlight():
    ledg.on()

def bluelight():
    ledb.on()

def lighton(which):
    aleds = [leds[k] for k in range(len(leds)) if which[k]]
    [x.on() for x in aleds]

def lightset(which):
    for (i, w) in enumerate(which):
        if w:
            leds[i].on()
        else:
            leds[i].off()

def blinkset(which):
    for (i, w) in enumerate(which):
        if w:
            leds[i].blink(0.7, 0.3)
        else:
            leds[i].off()

def alloff():
    [x.off() for x in leds]

if __name__ == "__main__":
    import time

    lightset([0, 0, 0])

    tests = [redlight, greenlight, bluelight,
             lambda: lightset([1, 1, 0]),
             lambda: lightset([1, 0, 1]),
             lambda: lightset([0, 1, 1]),
             ]

    for test in tests:
        print(test)
        test()
        print(ledr, ledg, ledb)
        time.sleep(1)
