class PropCache(object):
    cache = {}
    register = None

    def __init__(self, register):
        self.register = register

    def __getattribute__(self, key):
#        print(f'__getattribute__({key})')
        cache = object.__getattribute__(self, 'cache')
        register = object.__getattribute__(self, 'register')
        val = None
        if key in cache:
            val = cache[key]
#            print(f'found key {key} in cache: {val}')
        else:
            val = register.__getattribute__(key)
            cache[key] = val
#            print(f'fetch key {key} from registers: {val}')
        return val

    def __setattribute__(self, key, val):
        cache = object.__getattribute__(self, 'cache')
        register = object.__getattribute__(self, 'register')
        cache[key] = val
        register.__setattribute__(key, val)
        return val

    def clear(self):
        self.cache = {}

    def delete(self, key):
        del self.cache[key]
