
import queue
import threading
import time

class QueueReaderMT:

    def __init__(self, target):
        self.que = queue.Queue()
        self.target = target
        self.done = False
        self.sleepInter = 2e-3
        self.startThread()

    def readThread(self):
        print('queue reader thread started')
        while True:
            try:
                item = self.que.get(False)
            except queue.Empty:
                if self.done:
                  print('Queue is empty and stop set')
                  break
                else:
                  time.sleep(self.sleepInter)
                  continue
            self.target(item)
        print('queue reader thread stopped')

    def startThread(self):
        print('starting queue reader thread')
        thread = threading.Thread(target=lambda: self.readThread())
        thread.start()
